import java.util.Scanner;

/**
 * ForPlay - using for (& while) loops to print characters in String
 *    one per line. Includes alternative for syntax example too!
 *    Print char-by-char in sequence and in reverse sequence.
 *    Reconstruct String from char-by-char sequences.
 *
 * @author Section0X
 * @version 1.00 2012/10/20
 */

public class ForPlay
{
   public static void main( String[] args)
   {
      Scanner scan = new Scanner( System.in);
      
      System.out.println( "Start of ForPlay\n");
      
      // CONSTANTS
      
      // VARIABLES
      String s;
      int  charPosition;
      
      String reverseS;
      
      // PROGRAM CODE
      
      s = "abcde";
      
      // ******************************************************************
      // Using String methods...
      // ******************************************************************
      System.out.println( s.charAt(0) );
      System.out.println( s.charAt(1) );
      System.out.println( s.charAt(2) );
      System.out.println( s.charAt(3) );
      System.out.println( s.charAt(4) );
      System.out.println();
      
      System.out.println( s.length() );
      
      System.out.println( s.charAt( s.length() - 1 ) );
      
      System.out.println( s.concat( "xyz") );  //  equivalent to (s + "xyz")
      
      System.out.println( s.isEmpty() );
      System.out.println( s.indexOf( 'c') );
      System.out.println( s.indexOf( 'c', 3) ); // string.indexOf(searchvalue,start)  start: Optional. Default 0. At which position to start the search
      
      System.out.println( s.toUpperCase() );
      System.out.println( s.toLowerCase() );
      
      System.out.println( s.trim() ); // returns a copy of this string with leading and trailing white space removed
      System.out.println();
      
      // ******************************************************************
      // Printing String one character per line...
      // using conventional for statement
      // ******************************************************************
      for ( int i = 0; i < s.length(); i++)
      {
         System.out.println( s.charAt(i) );
      }
      System.out.println( "done ");  // try printing "i" here
      System.out.println();
      
      
      // ******************************************************************
      // using the alternative for syntax
      // ******************************************************************
      for ( char ch : s.toCharArray() ) // returns a newly allocated character array, whose length is the length of this string and whose contents are initialized to contain the character sequence represented by this string
         System.out.println( ch);
      System.out.println( "done ");
      System.out.println();
      
      
      // ******************************************************************
      // using while statement
      // ******************************************************************
      charPosition = 0;
      while ( charPosition < s.length() )
      {
         System.out.println( s.charAt( charPosition) );
         charPosition++;
      }
      System.out.println( "done ");
      System.out.println();
      
      
      // ******************************************************************
      // alternative solution using while statement
      // ******************************************************************
      while ( s.length() > 0 )
      {
         System.out.println( s.charAt(0) );
         s = s.substring(1);
      }
      System.out.println( "done ");
      System.out.println();
      
      
      // ******************************************************************
      // Printing characters in String in reverse sequence
      // reverse printing
      // ******************************************************************
      // s = "abcdef";
      
      for ( int i = s.length() - 1; i >= 0; i--)
      {
         System.out.println( s.charAt(i) );
      }
      System.out.println( "done ");
      System.out.println();
      
      
      // ******************************************************************
      // alternative reverse printing
      // ******************************************************************
      for ( int i = 0; i < s.length(); i++)
      {
         System.out.println( s.charAt( s.length() - 1 - i) );
      }
      System.out.println( "done ");
      System.out.println();
      
      
      // ******************************************************************
      // constructing reverse String - from forward sequence
      // ******************************************************************
      s = "abcdefghijklmnopqrstuvwxyz";
      
      reverseS = "*";       // ?what to initialise with?
      for ( int i = 0; i < s.length(); i++)
      {
         reverseS = reverseS + s.charAt( s.length() - 1 - i);
      }
      System.out.println( reverseS );
      System.out.println( "done ");
      System.out.println();
      
      
      // ******************************************************************
      // constructing normal String - from reverse sequence
      // ******************************************************************
      // TODO
      
      
      // ******************************************************************
      System.out.println( "\nEnd of ForPlay\n" );
   }
   
} // end of class ForPlay
